library(stockassessment)
load("run/model.RData")
FC<-list()
Ry<-2016:2020
set.seed(12345)
cw2 <- read.ices("data/cw2.dat")
fit2<-fit

cw <- fit2$data$catchMeanWeight
nr<-nrow(fit2$data$catchMeanWeight)
fit2$data$catchMeanWeight[nr+c(-4:0),]<-cw2[rep(nrow(cw2),5),]

# Forecast Status quo
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit2, fscale=c(NA,1,1), catchval=c(15663,NA,NA), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then Fsq", addTSB=TRUE,year.base=2021)

# Forecast Fmsy advice - Adopted by adg in 2020
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit2, catchval=c(15663,NA,NA), fval=c(NA,0.30,0.30), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then Fmsy", addTSB=TRUE,year.base=2021)

# Forecast Fmsy advice - As usual 
set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit2, catchval=c(15663,NA,NA), fval=c(NA,0.30,0.30), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then Fmsy", addTSB=TRUE,year.base=2021)
FC[[length(FC)+1]] <- forecast(fit2, fscale=c(1,NA,NA), fval=c(NA,0.30,0.30), rec.years=Ry, overwriteSelYears=2018:2020, label="Advice Fmsy", addTSB=TRUE,year.base=2021)

# Forecast Fpa
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit2, catchval=c(15663,NA,NA), fval=c(NA,0.52,0.52), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then Fpa", addTSB=TRUE,year.base=2021)

# Forecast Flim
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit2, catchval=c(15663,NA,NA), fval=c(NA,0.70,0.70), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then Flim", addTSB=TRUE,year.base=2021)

# Forecast F=0
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit2, catchval=c(15663,NA,NA), fval=c(NA,0.000001,0.000001), rec.years=Ry, overwriteSelYears=2018:2020, label="TAC=15663 then zero catch", addTSB=TRUE,year.base=2021)

save(FC, file="run/forecast.RData")
